#ifndef BUTTONEVENT_HPP
#define BUTTONEVENT_HPP

#include <string>

class ButtonEvent {
public:
    // Enum class for typeId
    enum class PressTypeId {
        SHORT_PRESS,
        LONG_PRESS,
        VERY_LONG_PRESS
    };

    // Enum class for sourceId
    enum class ButtonSourceId {
        BUTTON_0,
        BUTTON_1
    };

private:
    PressTypeId typeId;
    ButtonSourceId sourceId;

public:
    // Constructor
    ButtonEvent(PressTypeId typeId, ButtonSourceId sourceId);

    // Getters
    PressTypeId getTypeId() const;
    ButtonSourceId getSourceId() const;
};

#endif // BUTTONEVENT_HPP