#include "ButtonEvent.hpp"
#include "ButtonEventDispatcher.hpp"

#include "ButtonEventDispatcher.hpp"

ButtonEventDispatcher::ButtonEventDispatcher() : numHandlers(0) {}

void ButtonEventDispatcher::RegisterButtonHandler(void (*handler)(const ButtonEvent&)) {
    if (numHandlers < 4) {
        handlers[numHandlers++] = handler;
    } else {
        // Optionally handle error: Maximum number of handlers reached
    }
}

void ButtonEventDispatcher::UnregisterButtonHandler(void (*handler)(const ButtonEvent&)) {
    for (int i = 0; i < numHandlers; ++i) {
       // if (handlers[i].target<void(const ButtonEvent&)>() == handler) {
         if (handlers[i].target_type() == typeid(handler)) {
            handlers[i] = handlers[--numHandlers];
            return;
        }
    }
    // Optionally handle error: Handler not found
}

void ButtonEventDispatcher::Dispatch(const ButtonEvent& e) const {
    for (int i = 0; i < numHandlers; ++i) {
        handlers[i](e);
    }
}
