#ifndef BUTTONEVENTDISPATCHER_HPP
#define BUTTONEVENTDISPATCHER_HPP

#include <string>
#include <functional>
#include "ButtonEvent.hpp"

class ButtonEventDispatcher {
private:
    std::function<void(const ButtonEvent&)> handlers[4];
    int numHandlers;

public:

    // Constructor
    ButtonEventDispatcher();
    
    void RegisterButtonHandler(void (*handler)(const ButtonEvent& e));
    void UnregisterButtonHandler(void (*handler)(const ButtonEvent& e));
    void Dispatch(const ButtonEvent& e) const;
};

#endif // BUTTONEVENTDISPATCHER_HPP