typedef void (*ButtonEventCb)(const ButtonEvent& e);

class ButtonEventDispatcher
{
    static constexpr int cMaxHandlers = 4;

    private:
        ButtonEventCb handlers[cMaxHandlers];

    public:
        void RegisterButtonHandler(ButtonEventCb cb);
        void UnregisterButtonHandler(ButtonEventCb cb);
        void Dispatch(const ButtonEvent& e) const;
};
