#include <iostream>
#include "ButtonEvent.hpp"
#include "ButtonEventDispatcher.hpp"

void handler(int n, const ButtonEvent& e)
{
    std::cout << "handler" << n << "(button=" << static_cast<int>(e.sourceId) << ", press=" << static_cast<int>(e.typeId) << ")" << std::endl;
}

void handler1(const ButtonEvent& e)
{
    handler(1, e);
}

void handler2(const ButtonEvent& e)
{
    handler(2, e);
}

void handler3(const ButtonEvent& e)
{
    handler(3, e);
}

void handler4(const ButtonEvent& e)
{
    handler(4, e);
}

void handler5(const ButtonEvent& e)
{
    handler(5, e);
}

int main()
{
    ButtonEventDispatcher dispatcher{};

    // pre-define some button events
    ButtonEvent b0short{ButtonEvent::SourceId::cButton0, ButtonEvent::TypeId::cShortPress};
    ButtonEvent b1long{ButtonEvent::SourceId::cButton1, ButtonEvent::TypeId::cLongPress};
    ButtonEvent b0verylong{ButtonEvent::SourceId::cButton0, ButtonEvent::TypeId::cVeryLongPress};

    // register one handler
    dispatcher.RegisterButtonHandler(handler1);

    // dispatch event
    dispatcher.Dispatch(b0short);

    // register all handlers
    dispatcher.RegisterButtonHandler(handler2);
    dispatcher.RegisterButtonHandler(handler3);
    dispatcher.RegisterButtonHandler(handler4);
    dispatcher.RegisterButtonHandler(handler5);

    // dispatch event
    dispatcher.Dispatch(b1long);

    // remove handlers 2,3
    dispatcher.UnregisterButtonHandler(handler2);
    dispatcher.UnregisterButtonHandler(handler3);

    // dispatch event
    dispatcher.Dispatch(b0verylong);

    // add handler 5
    dispatcher.RegisterButtonHandler(handler5);

    // dispatch event
    dispatcher.Dispatch(b0short);
}