#include <array>

enum class typeIdType : int8_t
{
    cShortPress    = 0,
    cLongPress     = 1,
    cVeryLongPress = 2,
};

enum class sourceIdType : int8_t
{
    cButtonZero    = 0,
    cButtonOne     = 1,
};

class ButtonEvent
{
  private:
    typeIdType typeId;
    sourceIdType sourceId;
  public:
    ButtonEvent(typeIdType inputType, sourceIdType inputSource);
};

class ButtonEventDispatcher
{
  public:
    using callbackType = void (*)(const ButtonEvent&);
    void RegisterButtonHandler(callbackType myFct);
    void UnregisterButtonHandler(callbackType myFct);
    void Dispatch(const ButtonEvent& e) const;
    ButtonEventDispatcher();
  private:
    static const int8_t maxCallBackFunctions = 4;
    std::array<callbackType, maxCallBackFunctions> handlerFunctions {};
};
