#include <iostream>

class ButtonEvent 
{
    private: 
        std::string typeId;
        std::string sourceId;
    public:
        ButtonEvent(std::string typeId, std::string sourceId) : typeId(typeId), sourceId(sourceId){}
        std::string GetTypeId() const
        {
            return typeId;
        }
        std::string GetSourceId() const
        {
            return sourceId;
        }
};

class ButtonEventDispatcher {
    private:
        void(*handlers[4])(const ButtonEvent&);
        int hCount;

    public:
        ButtonEventDispatcher() : hCount(0) 
        {
            for (int i = 0; i < 4; ++i)
            {
                handlers[i] = nullptr;
            }
        } 

        void RegisterButtonHandler(void(*handler)(const ButtonEvent& e)) 
        {
            if (hCount < 4)
            {
                handlers[hCount] = handler;
                ++hCount;
            }
			else
			{
				std::cout << "Event despatcher full" << std::endl;
			}
        }

        void UnregisterButtonHandler(void(*handler)(const ButtonEvent& e))
        {
            for (int i = 0; i < hCount; ++i)
            {
                if (handlers[i] == handler)
                {
                    for (int j = i; j < hCount; ++j)
                    {
                        handlers[j] = handlers[j + 1];
                    }
                    handlers[hCount - 1] = nullptr;
                    --hCount;
                    return;
                }
            }
        }

        void Dispatch(const ButtonEvent& e) const
        {
            for (int i = 0; i < hCount; ++i)
            {
                if (handlers[i] != nullptr)
                {
                    (*handlers[i])(e);
                }
            }
        }
};